<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>leetcode-tips</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <p>If input array is sorted then - Binary search - Two pointers</p>
    <p>If asked for all permutations/subsets then - Backtracking</p>
    <p>If given a tree then - DFS - BFS</p>
    <p>If given a graph then - DFS - BFS</p>
    <p>If given a linked list then - Two pointers</p>
    <p>If recursion is banned then - Stack</p>
    <p>
      If asked for maximum/minumum subarray/subset/options then - Dynamic
      programming
    </p>
    <p>If asked for top/least K items then - Heap</p>
    <p>If asked for common strings then - Map - Trie</p>
    <p>
      Else - Map/Set for O(1) time &amp; O(n) space - Sort input for O(nlogn)
      time and O(1) space ```
    </p>
  </body>
</html>
